# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *
import glob
import re


def update_package():
    # Declaring local variables
    package_updated = False
    proxies = get_proxies_from_wapt_console()
    if not proxies:
        proxies = proxies = get_proxies()

    url_base = "https://www.charlesproxy.com/latest-release/download.do"
   


    paragraph = bs_find(url_base,"div", "class", "content")
    all_p_tags = paragraph.find_all('p')
    
    # Vérifier s'il y a au moins deux <p> tags 
    if len(all_p_tags) > 1:
        second_p_tag = all_p_tags[1]
        second_p_text = second_p_tag.get_text(strip=True)
        
        # Utiliser une expression régulière pour extraire la version
        version_match = re.search(r'(\d+\.\d+\.\d+)', second_p_text)
        if version_match:
            version = version_match.group(1)
        else:
            version = "Version non trouvée"
    else:
        version = "Deuxième paragraphe non trouvé"

    print(version)

    download_dict = {
        "windows-x64": "https://www.charlesproxy.com/assets/release/{version}/charles-proxy-{version}-win64.msi",
        "darwin-x64" :"https://www.charlesproxy.com/assets/release/{version}/charles-proxy-{version}.dmg",
        "linux-x64" : "https://www.charlesproxy.com/assets/release/{version}/charles-proxy-{version}_amd64.tar.gz"
    }
    
    download_url = download_dict[control.target_os + "-" + ensure_list(control.architecture)[0]].format(version=version)
    latest_bin = download_url.split("/")[-1]


    # Downloading latest binaries
    if not isfile(latest_bin):
        package_updated = True
        wget(download_url, latest_bin, proxies=proxies)

    filtre =  '*.' + latest_bin.split('.')[-1]
    for f in glob.glob(filtre):
        if f != latest_bin:
            remove_file(f)

    control.set_software_version(version)
    control.save_control_to_wapt()

    return package_updated